package eac5P2;
/**
 * Aquesta serà la classe principal del programa, és a dir on tindrem
 *  els mètodes main i inici així com el menú d’opcions del programa
 * @author José Luis Rodríguez Andrádez
 *
 */
import java.util.Scanner;

public class EAC5P2_001 {

	private static final int MAX = 10;
	Scanner scanner = new Scanner(System.in);
	
	
	dadesAplicacio dades = new dadesAplicacio();

	public static void main(String[] args) {
		EAC5P2_001 programa = new EAC5P2_001();
		programa.inici();
	}

	private void inici() {
		// Codi productes, Descripció , PVP
		String[][] productes = new String[MAX][3]; 
		//Codi producte,Descripció, PVP, Quantitat
		String[][] carroCompra = new String[MAX][5];
		
		boolean sortir = false;
		int opcio; 

		mostrarPresentacio();

		while (!sortir) {
			System.out.println();
			System.out.println("1. Afegir producte al catàleg");
			System.out.println("2. Afegir producte al carro de la compra");
			System.out.println("3. Llista de productes");
			System.out.println("4. Mostrar productes del carro de la compra");
			System.out.println("5. Sortir");
			System.out.println("Escriu el número de l'opció:");
			opcio = scanner.nextInt();

			switch (opcio) {
			case 1:
				afegirProductes(productes);
				break;
			case 2:
				afegirAlCarro(productes, carroCompra);
				break;
			case 3:
				mostrarLlistaProductes(productes);
				break;
			case 4:
				mostrarCarroCompra(carroCompra);
				break;
			case 5:
				fiPrograma();
				sortir = true;
				break;
			default:
				System.out.println("Només números entre 1 i 5");
			}
		}
	}
	
	private void afegirProductes(String[][] productes) {
		// Es demanaran les dades Codi Producte, descripció i PVP,
		// es comprovarà si aquest producte ja existeix en l’array «productes»
		// i si no hi és, doncs s’afegirà en l’array, de la forma següent:
		// dades.afegirProducte(codiProducte, descripcio, pvp, productes);
		scanner = new Scanner(System.in);
		String codiProducto;
		String descripcion;
		String  PVP;
		
		
		
		System.out.print("\nIntrodueix el codi del producte: ");
		codiProducto = scanner.nextLine();
				
		//Comprobar que no existe el producto
		if (dades.cercaCodiProducte(codiProducto, productes) == false) {
						
			System.out.print("\nIntrodueix la descripció del producte: ");
			descripcion = scanner.nextLine();
	
	
			System.out.print("\nIntrodueix el PVP del producte: ");
			PVP = scanner.nextLine();
			//Comprobamos que se insertan valores númericos
			PVP = dades.comprobarPVP(PVP);
	
			int PvpInt  = Integer.parseInt(PVP);
			dades.afegirProducte(codiProducto, descripcion, PvpInt, productes);
		}else{
			System.out.print("_________________________________\n"+
					         "El producto existe en el catalogo\n" +
					         "_________________________________\n");
		}
		
	}
	
	private void afegirAlCarro(String[][] productes, String[][] carroCompra) {
		scanner = new Scanner(System.in);
		String codiProducto = null;
		String descripcion = null;
		String PVP = null;
		int PvpInt = 0;
		int cantidad = 0;

		// Es demanara el codi del producte que es vol comprar, *
		// es comprovarà si existeix en l’array de «productes», *
		// en cas afirmatiu mostrarà la descripció del producte i el PVP, *
		// llavors demanarà la quantitat o unitats que es volen comprar *
		// i s’afegirà a l’array «carroCompra» les dades  *
		// Codi Producte, descripció, PVP i Quantitat de la forma següent:
		// dades.afegirAlCarro(codiProducte, descripcio, pvp, quantitat, carroCompra);
		//Comprobar que no existe el producto


		// Es demanara el codi del producte que es vol comprar,
		System.out.print("\nIntrodueix el codi del producte que desea comprar: ");
		codiProducto = scanner.nextLine();
		
		//Comprobamos que existe el producto, si existe continua
		if (dades.cercaCodiProducte(codiProducto, productes) == true) {
			/*for (int i = 0; (i < productes.length); i++) {
	        if (productes[i][0] != null) {
	        	if (productes[i][0].equals(codiProducto)) {*/
			// es comprovarà si existeix en l’array de «productes»,
			// en cas afirmatiu mostrarà la descripció del producte i el PVP,

			dades.cercaDescripcioProducte(codiProducto, productes);
			dades.cercaPreuProducte(codiProducto, productes);
			// Codi productes, Descripció , PVP
			for (int i = 0; (i < productes.length); i++) {
				if (productes[i][0].equalsIgnoreCase(codiProducto)) {
					System.out.print("\n__________________________________\n"
							+ "\tDATOS DEL PRODUCTO\n"
							+ "__________________________________\n"
							+ "codigo: " + productes[i][0] + "\t"
							+ "\tdescripción: " + productes[i][1] + "\t"
							+ "\tPVP: " + productes[i][2] + "\n");			


					// llavors demanarà la quantitat o unitats que es volen comprar
					System.out.print("\nIntrodueix la cantidad de producte que desea comprar: ");
					cantidad = scanner.nextInt();

					//Pasamos PVP de int a String para utilizarlo con el método afegirAlCarro
					PvpInt = Integer.parseInt(productes[i][2]);
					descripcion = productes[i][1];
					dades.afegirAlCarro(codiProducto, descripcion, PvpInt,cantidad,carroCompra);

				}

			}


		}else{
			System.out.print("_______________________\n"+
					"El producto no existe\n" +
					"_______________________\n");
		}

	}


	private void mostrarLlistaProductes(String[][] productes) {
		// Es mostren les dades de tots els productes de l’array «productes»
		
		//Comprueba que no hay nada en la lista
		if (productes[0][0] == null) {
			System.out.println("No hay ningún producto en la lista");
		}else{
			System.out.println("\nLa lista completa de productos son los siguientes" +
					"\n________________________________________________");
			//Si hay algo en la lista nos imprime los productos.
			for (int i = 0; i < productes.length; i++) {
				if (productes[i][0] != null) {
				System.out.println("Código: " + productes[i][0] + "\tDescripción: " + productes[i][1] + "\tPVP: " + productes[i][2]);
				}
			}
		}
	}

	private void mostrarCarroCompra(String[][] carroCompra) {
		// Es mostren les dades de l’array «carroCompra» amb les dades
		// Codi Producte, descripció, PVP,  Quantitat i Import (PVP * Quantitat).
		// Un cop mostrades totes les dades del carro de la compra, 
		// es mostrarà l’import total del carro de la compra, 
		// és a dir la suma dels imports de totes les línies de la comanda, 
		// tenint en compte que per cada línia l’import és PVP * Quantitat.
		int suma = 0;
		int total = 0;
		
		//Comprueba que no hay nada en la lista
		for (int x = 0; x < carroCompra.length; x++) {
			if (carroCompra[0][0] == null) {
				System.out.println("No hay ningún producto en la lista");
			}else{
				System.out.println("La lista completa del carro de la compra son los siguientes"+
						"\n_____________________________________________________________");
				for (int y = 0; y < carroCompra.length; y++) {
					if (carroCompra[y][0] != null) {
						System.out.println("Codigo: " + carroCompra[y][0]
								+ "\t\t Descripción: " + carroCompra[y][1]
										+ "\t PVP: " + carroCompra[y][2]
												+ "\t Cantidad: " + carroCompra[y][3]
														+ "\t\t Total:" + carroCompra[y][4]);
						suma = Integer.parseInt(carroCompra[y][4]);
						total += suma;
					}
				}

				System.out.println("Importe Total: " + total);
				return;
			}
		}
		
	}
	
	//Método que presenta información del programa.
	private void mostrarPresentacio() {
		System.out.println("Programa para gestionar productor y carro de la compra");
	}
	
	//Método que soluciona el subproblema de finalizar el programa.
	private void fiPrograma() {
		System.out.println("Finalizar programa");
	}
}
